unit U_GUI;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls;

type
  TF_nDamen = class(TForm)
    DrawGrid1: TDrawGrid;
    CB_Vorschau: TCheckBox;
    Button1: TButton;
    CB_FalscheZualssen: TCheckBox;
    procedure DrawGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure CB_VorschauClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure CB_FalscheZualssenClick(Sender: TObject);
  private
    { Private declarations }
    feld: array[0..7,0..7] of boolean;
    zeile_bedroht: array[0..7] of boolean;
    spalte_bedroht: array[0..7] of boolean;
    aufdiag_bedroht: array[0..14] of boolean;
    abdiag_bedroht: array[-7..7] of boolean;
    procedure Aktualisieren;

  public
    { Public declarations }
  end;

var
  F_nDamen: TF_nDamen;

implementation

{$R *.dfm}


procedure TF_nDamen.Aktualisieren;
var z,s: integer;
    Rect: TRect;
begin
  DrawGrid1.Canvas.Brush.style:= bsSolid;
  for z:= 0 to 7
  do for s:= 0 to 7
     do begin
          Rect:= DrawGrid1.CellRect(z,s);
          if Feld[s,z]
          then DrawGrid1.Canvas.brush.color:= clBlack
          else begin
                 if (zeile_bedroht[z] or spalte_bedroht[s] or aufdiag_bedroht[s+z] or abdiag_bedroht[s-z]) and (CB_Vorschau.Checked)
                 then DrawGrid1.Canvas.brush.color:= clRed
                 else DrawGrid1.Canvas.brush.color:= clwhite
               end;  
          DrawGrid1.Canvas.FillRect(Rect);
        end;

end;

procedure TF_nDamen.DrawGrid1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var z,s: integer;
begin
  DrawGrid1.MouseToCell(x,y,z,s);
  if not (zeile_bedroht[z] or spalte_bedroht[s] or aufdiag_bedroht[s+z] or abdiag_bedroht[s-z]) or
         (feld[s,z]) or
         (CB_FalscheZualssen.Checked)
  then begin
         feld[s,z]:= not feld[s,z];
         zeile_bedroht[z]:= not zeile_bedroht[z];
         spalte_bedroht[s] := not spalte_bedroht[s];
         aufdiag_bedroht[s+z]:= not aufdiag_bedroht[s+z];
         abdiag_bedroht[s-z]:= not abdiag_bedroht[s-z];
       end;
  DrawGrid1.Repaint;
  Aktualisieren;
end;


procedure TF_nDamen.FormCreate(Sender: TObject);
var s, z: integer;
begin
  for s:= 0 to 7 do for z:= 0 to 7
  do begin
        feld[s,z]:= false;
        zeile_bedroht[z]:= false;
        spalte_bedroht[s] := false;
        aufdiag_bedroht[s+z]:= false;
        abdiag_bedroht[s-z]:= false;
     end;
  Aktualisieren;
end;

procedure TF_nDamen.CB_VorschauClick(Sender: TObject);
begin
  Aktualisieren;
end;

procedure TF_nDamen.Button1Click(Sender: TObject);
var s, z: integer;
begin
  for s:= 0 to 7 do for z:= 0 to 7
  do begin
        feld[s,z]:= false;
        zeile_bedroht[z]:= false;
        spalte_bedroht[s] := false;
        aufdiag_bedroht[s+z]:= false;
        abdiag_bedroht[s-z]:= false;
     end;
  Aktualisieren;
end;

procedure TF_nDamen.CB_FalscheZualssenClick(Sender: TObject);
begin
  if CB_FalscheZualssen.Checked = true
  then begin
         CB_Vorschau.Checked:= false;
         CB_Vorschau.Enabled:= false;
       end
  else CB_Vorschau.Enabled:= true;

end;

end.
